/**
* www.rellect.com
*/

var rellect = rellect || {};
rellect.AdblockDetector = rellect.AdblockDetector || {};

!function($, window, document, _undefined)
{
	$.extend(rellect.AdblockDetector, {
		setAlertCookie: function()
		{
			var expiry = new Date();
			expiry.setTime(expiry.getTime() + (this.expiry * 1000)); /* milliseconds */
			$.setCookie('adblock_alert', this.hours, expiry); /* delete cookie */
		},
		tracking: function(action)
		{
			/**
			* This will be written in the future
			*/
		},
		dismissed: function()
		{
			this.tracking('Alert Dismissed');

			if(this.hours != '-1')
				this.setAlertCookie();
		},
		notice: function()
		{
			$('.adblock_notice').show();
		},
		FloatingMessage: function()
		{
			title = String(this.phrases.title || 'Missing phrase');
			message = String(this.phrases.message || 'Missing phrase');

			$html = $(''
				+ '<div class="adblock_detector adblock_floating_message" style="display:none">'
				+ 	'<div class="errorDetails">'
				+ 		'<div class="alertIcon"></div>'
				+ 		'<a class="close">&#10006;</a>'
				+ 		'<div class="errorMessage">'+message+'</div>'
				+ 	'</div>'
				+ '</div>'
			);

			if(!this.canDismiss)
			{
				$html.find('.close').css('display', 'none');
			}

			if (XenForo.isTouchBrowser())
			{
				$html.css('position', 'absolute');
			}

			var alertHolder = $html.prependTo("body"),
				alertHeight = alertHolder.height();
			alertHolder.show();
			$("html").css('padding-top', alertHeight);

			alertHolder.find('.close').click(function(){
				$("html").css('padding-top', 0);
			});

			var htmlWidth = $('html').width();
			$(window).on('resize orientationchange', function(e){
				if ($('html').width() == htmlWidth && alertHeight == alertHolder.height())
				{
					return;
				}
				alertHeight = alertHolder.height();
				$("html").css('padding-top', alertHeight);
				htmlWidth = $('html').width();
			});
		},
		/**
		* Default overlay error alert
		*/
		overlay: function()
		{
			title = String(this.phrases.title || 'Missing phrase');
			message = String(this.phrases.message || 'Missing phrase');

			var key = message.replace(/[^a-z0-9_]/gi, '_'),
				$overlayHtml;

			if (XenForo._OverlayCache[key] === undefined)
			{
				$overlayHtml = $(''
					+ '<div class="errorOverlay">'
					+ 	'<a class="close OverlayCloser"></a>'
					+ 	'<h2 class="heading">' + title + '</h2>'
					+ 	'<div class="baseHtml errorDetails">'+ message +'</div>'
					+ '</div>'
				);

				if(!this.canDismiss)
				{
					$overlayHtml.find('.OverlayCloser').css('display', 'none');
				}

				XenForo._OverlayCache[key] = XenForo.createOverlay(null, $overlayHtml, {
					onBeforeClose: function()
					{
						/* Disallow to dismiss alert */
						if(!rellect.AdblockDetector.canDismiss)
						{
							return false;
						}
						rellect.AdblockDetector.dismissed();
					}
				});
			}

			XenForo._OverlayCache[key].load();

			return $overlayHtml;
		}
	});
	$(function()
	{
		var script = document.createElement('script');
		script.async = true;
		$(script).load(function(){
			rellect.AdblockDetector.tracking('Off');
		}).error(function(){
			/**
			* This script failed to load, Means adblocker blocked it
			* TODO: add a check to ensure it isn't failed because of time out, and such
			*/
			if(rellect.AdblockDetector.showAlert)
			{
				switch(rellect.AdblockDetector.type)
				{
					case 'float': rellect.AdblockDetector.FloatingMessage(); break;
					case 'overlay': rellect.AdblockDetector.overlay(); break;
					case 'notice': rellect.AdblockDetector.notice(); break;
				}

				/* Dismiss event */
				$('.adblock_detector .close').click(function(){
					$('.adblock_detector').fadeOut("slow");
					rellect.AdblockDetector.dismissed();
				});
			}

			rellect.AdblockDetector.tracking('Enabled');
		});

		if(rellect.AdblockDetector.whitelisted)
			script.src = '//pagead2.googlesyndication.com/pagead/show_ads.js';
		else
			script.src = _bH+'/js/rellect/AdblockDetector/advertisement.js?v=1.1.0';

		document.getElementsByTagName('head')[0].appendChild(script).remove();
	});
}
(jQuery, this, document);