<?php

class rellect_AdblockDetector_Install_Controller
{
	public static function install($existingAddOn, $addOnData, SimpleXMLElement $xml = null)
	{
		if (XenForo_Application::$versionId < 1020000)
		{
			throw new XenForo_Exception('This add-on requires XenForo 1.2 or higher.', true);
		}

		if (!$existingAddOn)
		{
			// New installation
			self::jumpToStep(1);
		}
		else
		{
			// Upgrades
			if($addOnData['version_id'] > $existingAddOn['version_id'])
			{
				self::jumpToStep($addOnData['version_id'] + 1);
			}
		}
	}

	public static function uninstall()
	{
	}

	/**
	* Upgrades queue
	* @var		int		step number
	*/
	public static function jumpToStep($stepNumber)
	{
		$db = XenForo_Application::get('db');

		$step = 'step'.$stepNumber;
		if(method_exists(get_class(), $step))
		{
			$flag = self::$step($db);
			self::jumpToStep($stepNumber + 1);
		}
	}

	private static function step1(&$db)
	{
		// nothing to do
	}

	private static function step2(&$db)
	{
		// Set default permissions data
		$db->query("
			INSERT IGNORE INTO xf_permission_entry
				(user_group_id, user_id, permission_group_id, permission_id, permission_value, permission_value_int)
			VALUES
				#Guests
				(1, 0, 'general', 'canDismissAdBlockAlert', 'allow', 0),
				(1, 0, 'general', 'AdBlockAlertTiming', 'use_int', -1),
				
				#Registered
				(2, 0, 'general', 'canDismissAdBlockAlert', 'allow', 0),
				(2, 0, 'general', 'AdBlockAlertTiming', 'use_int', -1),
				
				#Admins
				(3, 0, 'general', 'canDismissAdBlockAlert', 'allow', 0),
				(3, 0, 'general', 'AdBlockAlertTiming', 'use_int', -1),
				(3, 0, 'general', 'bypassAdBlock', 'allow', 0),
				
				#Mods
				(4, 0, 'general', 'canDismissAdBlockAlert', 'allow', 0),
				(4, 0, 'general', 'AdBlockAlertTiming', 'use_int', -1)
		");
	}
}

?>